## glite-lb-server 3.0.18

=== Makefile ===
# defaults
top_srcdir=..
stagedir=.
globalprefix=glite
lbprefix=lb
package=glite-lb-server
version=0.2.0
PREFIX=/opt/glite
prefix=
sysconfdir=/opt/glite/etc

# gridsite requires openssl libraries, we want to include the ones from globus
globus_prefix=/opt/globus
expat_prefix=/opt/expat
cares_prefix=/opt/c-ares
gsoap_prefix=/opt/gsoap
classads_prefix=/opt/classads
voms_prefix=/opt/glite
lcas_prefix=/opt/glite
gridsite_prefix=/opt/glite

default: all

-include Makefile.inc
-include ${top_srcdir}/project/version.properties

version=${module.version}
docdir?=${prefix}/share/doc/${package}-${version}

SOURCES=\
	config/glite-lb* config/my.cnf config/*.conf config/startup config/startup.* config/setup config/systemd.* \
	doc/*.1 doc/*.8 \
	interface/*.h \
	src/*.c src/*.cpp src/*.h src/*.c.T src/*.l src/*.y src/*.sh src/*.sh.in src/ws_typemap.dat \
	project/.post* project/.pre* \
	test/*.cpp test/*.cpp.T test/*.sh test/oneJob.qry test/*.c \
	Makefile
SOURCES_EXEC=config/glite-lb-migrate* config/startup config/startup.* config/setup src/*.sh test/*.sh

all: compile

GLITE_LB_SERVER_WITH_WS=yes
GLITE_LB_SERVER_WITH_LCAS=no

ifdef LB_STANDALONE
	LB_STANDALONE_FLAGS:=-DLB_STANDALONE
#	GLITE_LB_SERVER_WITH_WS=no
endif

ifdef LB_PERF
	STATIC_LIB_BK:=libglite_lb_bkserver_perf.a
	LB_PERF_FLAGS:=-DLB_PERF
else
	STATIC_LIB_BK:=libglite_lb_bkserver.a
endif

ifeq ($(GLITE_LB_SERVER_WITH_WS),yes)
	WS_CFLAGS=-DGLITE_LB_SERVER_WITH_WS 
	NSMAP=LoggingAndBookkeeping.nsmap
else
	WS_CFLAGS=
endif

sysdefaultdir?=${sysconfdir}/default

ifeq ($(os_type),systemd)
unitdir=`pkg-config systemd --variable=systemdsystemunitdir`
endif
mysqlconfdir?=${sysconfdir}/mysql/conf.d

GSOAP_FILES_PREFIX:= bk_ws_

YACC=bison -y
CC=gcc
CXX=g++

ifeq ($(gsoap_version),2.7.0)
	VPATH=${top_srcdir}/interface:${top_srcdir}/src:${top_srcdir}/test:${top_srcdir}/doc:${top_srcdir}/examples:${top_srcdir}/project:${gsoap_prefix}
else
	VPATH=${top_srcdir}/interface:${top_srcdir}/src:${top_srcdir}/test:${top_srcdir}/doc:${top_srcdir}/examples:${top_srcdir}/project
endif
AT3=${stagedir}${prefix}/bin/glite-lb-at3

SUFFIXES = .T 

DEBUG:=-g -O0 -Wall

ifeq (${thrflavour},)
default_flavour=
vomsflavour:=
else
default_flavour=_${nothrflavour}
vomsflavour:=_${nothrflavour}
ifeq (${nothrflavour},gcc32) 
	vomsflavour :=
endif 
ifeq (${nothrflavour},gcc32dbg)
	vomsflavour :=
endif
endif

GRIDSITE_CFLAGS?=-I${gridsite_prefix}/include `xml2-config --cflags`
GRIDSITE_LIBS?=-L${gridsite_prefix}/${libdir} -L${gridsite_prefix}/lib -lgridsite `xml2-config --libs`

ifeq (${GLITE_LB_SERVER_WITH_LCAS},yes)
LCAS_CFLAGS?=-I${lcas_prefix}/include -I${lcas_prefix}/include/glite/security -DHAVE_LCAS
LCAS_LIBS?=-L${lcas_prefix}/${libdir} -llcas
endif

ifneq (${classads_prefix},/usr)
	classads_libs := -L${classads_prefix}/${libdir} -L${classads_prefix}/lib
endif
CLASSADS_CFLAGS?=-I${classads_prefix}/include -I${classads_prefix}/include/classad
CLASSADS_LIBS?=${classads_libs} -lclassad
classad_namespace:=${shell if ${classads_prefix}/bin/classad_version | grep -i 'classad namespace.*no' >/dev/null; then echo no; else echo yes; fi 2>/dev/null}
ifeq (${classad_namespace},yes)
CLASSADS_CFLAGS+=-DCLASSAD_NAMESPACE=classad::
else
CLASSADS_CFLAGS+=-DCLASSAD_NAMESPACE=
endif

ifneq (${cares_prefix},/usr)
	cares_libs := -L${cares_prefix}/${libdir} -L${cares_prefix}/lib
endif
LIBCARES_CFLAGS?=-I${cares_prefix}/include
LIBCARES_LIBS?=${cares_libs} -lcares

GSOAP_CFLAGS?=-I${gsoap_prefix}/include -I${gsoap_prefix}/
ifeq (${expat_prefix},/usr)
EXPAT_CFLAGS?=
EXPAT_LIBS?=-lexpat
else
EXPAT_CFLAGS?=-I${expat_prefix}/include
EXPAT_LIBS?=-L${expat_prefix}/${libdir} -lexpat
endif
GLOBUS_GSSAPI_GSI_CFLAGS?=-I${globus_prefix}/include/${nothrflavour}
KERBEROS_GSSAPI_GSI_CFLAGS=-DNO_GLOBUS_GSSAPI

CPPUNIT_LIBS?=-L${cppunit_prefix}/${libdir} -lcppunit
CPPUNIT_CFLAGS?=-I${cppunit_prefix}/include

VOMS_CFLAGS?=-I${voms_prefix}/include -I${voms_prefix}/include/glite/security
VOMS_LIBS?=-L${voms_prefix}/${libdir} -lvomsapi${vomsflavour}

GLITE_LBJP_COMMON_CFLAGS?=`PKG_CONFIG_PATH=$$PKG_CONFIG_PATH:${PREFIX}${prefix}/${libdir}/pkgconfig pkg-config glite-security-gss glite-security-gsoap-plugin --cflags`

ifeq ($(gssapi_provider), kerberos)
GSSAPI_GSI_CFLAGS=${KERBEROS_GSSAPI_GSI_CFLAGS}
VOMS_LIBS=
VOMS_CFLAGS=
else
GSSAPI_GSI_CFLAGS=${GLOBUS_GSSAPI_GSI_CFLAGS}
endif

CXXFLAGS?=${CFLAGS}

CPPFLAGS:= \
	${GSSAPI_GSI_CFLAGS} \
	${WS_CFLAGS} \
	-DVERSION=\"${version}\" \
	 ${GSOAP_CFLAGS} \
	-I${stagedir}${prefix}/include -I${top_srcdir}/src -I. \
	-I${top_srcdir}/interface \
	${EXPAT_CFLAGS} \
	${LIBCARES_CFLAGS} \
	${CLASSADS_CFLAGS} \
	${VOMS_CFLAGS} \
	$(GRIDSITE_CFLAGS) ${LCAS_CFLAGS} ${GSOAP_CFLAGS} \
	-D_GNU_SOURCE ${LB_STANDALONE_FLAGS} ${LB_PERF_FLAGS} -DLB_EVENTS_BLOB \
	${GLITE_LBJP_COMMON_CFLAGS}

CFLAGS:=${CPPFLAGS} ${DEBUG} ${COVERAGE_FLAGS} ${CFLAGS}
CXXFLAGS:=${CPPFLAGS} ${DEBUG} ${COVERAGE_FLAGS} ${CXXFLAGS}

ifdef LB_PROF
	SRVBONES_LIB:= ${stagedir}${prefix}/${libdir}/libglite_lbu_server_bones.la
	LB_COMMON_LIB:=${stagedir}${prefix}/${libdir}/libglite_lb_common${default_flavour}.la
	LB_UTILS_DB_LIB:=${stagedir}${prefix}/${libdir}/libglite_lbu_db.la
	CFLAGS:=${CFLAGS} -pg -g
	LDFLAGS:=${LDFLAGS} -pg
else
	SRVBONES_LIB:= -L${stagedir}${prefix}/${libdir} -lglite_lbu_server_bones
	LB_COMMON_LIB:=-L${stagedir}${prefix}/${libdir} -lglite_lb_common${default_flavour}
	LB_UTILS_DB_LIB:=-L${stagedir}${prefix}/${libdir} -lglite_lbu_db
	LDFLAGS:=${LDFLAGS} -L${stagedir}${prefix}/${libdir}
endif

# LB_MACHINE_LIB:=${stagedir}${prefix}/${libdir}/libglite_lb_statemachine.a
LB_MACHINE_LIB:=-L${stagedir}${prefix}/${libdir} -lglite_lb_statemachine

ifdef LBS_DB_PROFILE
	CFLAGS:=${CFLAGS} -DLBS_DB_PROFILE
endif

COMPILE:=libtool --mode=compile ${CC} ${CFLAGS}
CXXCOMPILE:=libtool --mode=compile ${CXX} ${CXXFLAGS}
LINK:=libtool --mode=link ${CC} ${LDFLAGS}
SOLINK:=libtool --mode=link ${CC} -module ${LDFLAGS} -rpath ${stagedir}${prefix}/${libdir}
INSTALL:=libtool --mode=install install
LINKXX:=libtool --mode=link  ${CXX} ${LDFLAGS}
XSLTPROC:=xsltproc --novalid

gsoap_bin_prefix:=${shell if [ -x  ${gsoap_prefix}/bin/soapcpp2 ]; then echo ${gsoap_prefix}/bin; else echo ${gsoap_prefix}; fi }

EXT_LIBS:=  \
	${GRIDSITE_LIBS} \
	${CLASSADS_LIBS} \
	${LIBCARES_LIBS} \
	-lcrypto -lssl

ifeq ($(gssapi_provider), kerberos)
else
EXT_LIBS+= \
	${LCAS_LIBS} \
	${VOMS_LIBS}
endif

COMMON_LIBS:= -L${stagedir}${prefix}/${libdir} -lglite_lb_common${default_flavour} -lglite_security_gss${default_flavour} -lglite_lbu_trio -lglite_lbu_maildir -lglite_lbu_log

BKSERVER_BASE_OBJS:= \
	bkserverd.o il_lbproxy.o get_events.o index.o jobstat.o jobstat_supp.o \
	seqcode.o write2rgma.o lb_html.o lb_http.o lb_proto.o cond_dump.o lb_xml_parse.o \
	lb_xml_parse_V21.o lb_text.o \
	openserver.o query.o userjobs.o db_store.o request.o store.o \
	stored_master.o srv_purge.o server_state.o dump.o lb_authz.o load.o \
	notification.o il_notification.o notif_match.o stats.o server_stats.o db_calls.o db_supp.o lb_rss.o pretty_print_wrapper.o \
	policy_gram.o policy_lex.o authz_policy.o crypto.o

gsoap_version ?= ${gsoap_default_version}

dotless_gsoap_ver:=${shell echo ${gsoap_version} | tr -d . }
ifeq ($(shell test -f ${stagedir}${prefix}/${libdir}/libglite_security_gsoap_plugin_${dotless_gsoap_ver}${default_flavour}_c.so && echo ok),ok)
	langflavour:=_c
endif
GSOAP_LIB:=-L${stagedir}${prefix}/${libdir} -lglite_security_gsoap_plugin_${dotless_gsoap_ver}${default_flavour}${langflavour} -lglite_security_gss${default_flavour} ${GSOAP_LIBS}

ifeq ($(GLITE_LB_SERVER_WITH_WS),yes)
	BKSERVER_OBJS:= \
		${BKSERVER_BASE_OBJS} \
		${GSOAP_FILES_PREFIX}C.o ${GSOAP_FILES_PREFIX}Server.o \
		ws_query.o ws_lb4agu.o ws_fault.o ws_typeref.o

	BKSERVER_LIBS= \
		${SRVBONES_LIB} \
		${LB_COMMON_LIB} \
		${LB_MACHINE_LIB} \
		${LB_UTILS_DB_LIB} \
		${GSOAP_LIB} \
		${EXT_LIBS} \
		${EXPAT_LIBS} \
		-lglite_lbu_maildir \
		-lglite_lbu_log \
		-lglite_lbu_trio \
		-lglite_jobid
else
	BKSERVER_OBJS:= ${BKSERVER_BASE_OBJS}
		
	BKSERVER_LIBS= \
		${SRVBONES_LIB} \
		${LB_COMMON_LIB} \
		${LB_MACHINE_LIB} \
		${LB_UTILS_DB_LIB} \
		-lglite_security_gss${default_flavour} \
		${EXT_LIBS} \
		${EXPAT_LIBS} \
		-lglite_lbu_maildir \
		-lglite_lbu_log \
		-lglite_lbu_trio \
		-lglite_jobid
endif

INDEX_OBJS:= index.o index_parse.o jobstat_supp.o openserver.o \
	jobstat.o query.o get_events.o write2rgma.o index_lex.o \
	lb_authz.o store.o bkindex.o stats.o server_stats.o\
	request.o db_store.o srv_purge.o notif_match.o il_lbproxy.o dump.o lb_xml_parse.o il_notification.o lb_proto.o lb_text.o server_state.o lb_xml_parse_V21.o lb_html.o cond_dump.o notification.o seqcode.o userjobs.o load.o db_calls.o db_supp.o lb_rss.o pretty_print_wrapper.o authz_policy.o crypto.o

INDEX_LIBS:= ${SRVBONES_LIB} ${COMMON_LIBS} ${LB_MACHINE_LIB} ${EXT_LIBS} \
	${EXPAT_LIBS} ${LB_UTILS_DB_LIB} -lglite_lbu_trio -lglite_jobid

WS_CLIENT_OBJS:= $(GSOAP_FILES_PREFIX)C.o $(GSOAP_FILES_PREFIX)Client.o ws_fault.o ws_typeref.o
WS_CLIENT_LIBS:= ${GSOAP_LIB} -lglite_lb_common${default_flavour} \
	-lglite_lb_common${default_flavour}

HDRS=index.h lb_authz.h store.h

MAN1_GZ:=glite-lb-mon-db.1.gz
MAN8_GZ:=glite-lb-bkindex.8.gz glite-lb-bkserverd.8.gz glite-lb-export.8.gz glite-lb-migrate_db2version20.8.gz glite-lb-migrate_db2version40.8.gz glite-lb-notif-keeper.8.gz glite-lb-setup.8.gz
MAN_GZ:=$(MAN1_GZ) $(MAN8_GZ)
MAN = $(MAN_GZ:.gz=)

LIB_OBJS_BK:= \
	il_lbproxy.o get_events.o index.o jobstat.o jobstat_supp.o \
	seqcode.o lb_html.o lb_http.o lb_proto.o cond_dump.o lb_xml_parse.o \
	lb_xml_parse_V21.o lb_text.o \
	openserver.o query.o userjobs.o db_store.o request.o store.o \
	stored_master.o srv_purge.o server_state.o dump.o lb_authz.o load.o \
	notification.o il_notification.o notif_match.o stats.o server_stats.o write2rgma.o \
	db_calls.o db_supp.o lb_rss.o pretty_print_wrapper.o authz_policy.o \
	crypto.o

MONDB_OBJS:=mon-db.o ${LIB_OBJS_BK}
MONDB_LIBS:=${COMMON_LIBS} ${LB_MACHINE_LIB} ${LB_UTILS_DB_LIB} ${EXT_LIBS} \
	${EXPAT_LIBS} -lglite_lbu_trio -lglite_jobid

ifeq (${GLITE_LB_SERVER_WITH_LCAS},yes)
LCAS_PLUGIN_OBJS:=lcas_lb.o
LCAS_PLUGIN_LOBJS:=${LCAS_PLUGIN_OBJS:.o=.lo}
LCAS_PLUGIN_LIB:=liblcas_lb.la
endif

EXAMPLES=

TESTS=test_coverage test_xml test_query_events test_soap_conv test_query_parse

SCRIPTS=startup setup glite-lb-server-purge.cron glite-lb-proxy-purge.cron glite-lb-notif-keeper.cron glite-lb
SCRIPTS2=export.sh notif-keeper.sh
SCRIPTS_SRC=$(addprefix ${top_srcdir}/config/,${SCRIPTS})

glite-lb-bkserverd: ${NSMAP} ${BKSERVER_OBJS}
	${LINKXX} -o $@ ${BKSERVER_OBJS} ${BKSERVER_LIBS} -Wl,--export-dynamic

glite-lb-bkindex: ${INDEX_OBJS}
	${LINKXX} -o $@ ${INDEX_OBJS} ${INDEX_LIBS}

glite-lb-mon-db: ${MONDB_OBJS}
	${LINKXX} -o $@ ${MONDB_OBJS} ${MONDB_LIBS}

compile: generate ${SCRIPTS} ${SCRIPTS2} glite-lb-bkserverd glite-lb-bkindex glite-lb-mon-db ${STATIC_LIB_BK} ${LCAS_PLUGIN_LIB} ${MAN_GZ}

generate: store.c index.c 

${SCRIPTS}: ${SCRIPTS_SRC}
	glite_var="${localstatedir}/glite"; \
	if echo "${localstatedir}" | grep 'glite'>/dev/null; then \
		glite_var="${localstatedir}"; \
	fi; \
	sed -e 's:@glite_prefix@:${sysroot}${prefix}:g' -e 's:@glite_etc@:${sysconfdir}:g' -e "s:@glite_var@:$$glite_var:g" -e 's:@defaultdir@:${sysdefaultdir}:g' -e 's:@mysqlconfdir@:${mysqlconfdir}:' ${top_srcdir}/config/$@ > $@
ifneq ($(os_type),debian)
	sed -i 's/# \(Default-Start\|Default-Stop\):.*/# \1:/' $@
endif
	sed "s/^@$(os_type)@//" $@ > $@.tmp
	grep -v '^@' $@.tmp > $@
	rm $@.tmp

%.sh: %.sh.in
	glite_var="${localstatedir}/glite"; \
	if echo "${localstatedir}" | grep 'glite'>/dev/null; then \
		glite_var="${localstatedir}"; \
	fi; \
	sed -e 's:@glite_prefix@:${sysroot}${prefix}:g' -e 's:@glite_etc@:${sysconfdir}:g' -e "s:@glite_var@:$$glite_var:g" -e 's:@defaultdir@:${sysdefaultdir}:g' $< > $@

# XXX test.query disabled (coredumps, doesn't build anymore_
check: compile test.xml test.query_parse

test_coverage:
	-mkdir coverage

=== debian/changelog ===
glite-lb-server (3.0.18-1.git20151003) stable; urgency=low

  * Automatically generated package

 -- CESNET Product Teams <emi-lb@metacentrum.cz>  Sat, 03 Oct 2015 10:10:50 +0200

=== debian/control ===
Source: glite-lb-server
Priority: extra
Maintainer: CESNET Product Teams <emi-lb@metacentrum.cz>
Uploaders: František Dvořák <valtri@civ.zcu.cz>
Build-Depends: debhelper (>= 7.0.50~), bison, flex, glite-lb-types, glite-lb-ws-interface, gsoap, libc-ares-dev, libclassad-dev, libcppunit-dev, libexpat1-dev, libglite-jobid-api-c-dev, libglite-lb-common-dev, libglite-lb-state-machine-dev, libglite-lbjp-common-db-dev, libglite-lbjp-common-gss-dev, libglite-lbjp-common-gsoap-plugin-dev, libglite-lbjp-common-log-dev, libglite-lbjp-common-maildir-dev, libglite-lbjp-common-server-bones-dev, libglite-lbjp-common-trio-dev, libgridsite-dev, libtool-bin, libxml2-dev, lsb-base (>= 3.2-14), pkg-config, voms-dev
# gssapi.h is needed explicitly for glite-lb-server, but the proper package is
# known only in libglite-lbjp-common-gss-dev:
#  - gssapi from Globus (libglobus-gssapi-gsi-dev)
#  - gssapi from MIT Kerberos (libkrb5-dev)
#  - gssapi from Heimdal Kerberos (heimdal-dev)
#Build-Depends: libglobus-gssapi-gsi-dev
Standards-Version: 3.9.1
Section: misc
Homepage: http://glite.cern.ch

Package: glite-lb-server
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, mysql-server, glite-lb-client-progs, glite-lb-utils, glite-lbjp-common-log, adduser
Description: gLite Logging and Bookkeeping server
 glite-lb-server is the gLite Logging and Bookkeeping server. This package
 contains the L&B server daemon (glite-lb-bkserverd) and a tool for rebuilding
 server indices
 (glite-lb-bkindex).

Package: glite-lb-server-dbg
Section: debug
Architecture: any
Depends: glite-lb-server (= ${binary:Version}), ${misc:Depends}
Description: Debugging symbols for gLite L&B server
 glite-lb-server is the gLite Logging and Bookkeeping server. This package
 contains the L&B server daemon (glite-lb-bkserverd) and a tool for rebuilding
 server indices
 (glite-lb-bkindex).
 .
 This package contains debugging symbols for gLite L&B server.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
-include /usr/share/dpkg/buildflags.mk

p_base=glite-lb-server
p_dbg=glite-lb-server-dbg

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# condor classads requires 2011 ISO C++ standard since Debian 8 jessie
classad_version=$(shell dpkg-query -W libclassad0-dev libclassad-dev | cut -f2)
classad_cxxflags=$(shell if dpkg --compare-versions $(classad_version) '>=' '8'; then echo '-std=c++11'; fi)

%:
	dh $@ --parallel --fail-missing

override_dh_auto_configure: config.status
config.status:
	./configure --root=/ --prefix=/usr --libdir=lib --docdir=/usr/share/doc/$(p_base) --mysqlconfdir=/etc/mysql/conf.d --sysdefaultdir=/etc/default --os-type=debian --project=emi

override_dh_auto_build:
	CXXFLAGS="$(CXXFLAGS) $(classad_cxxflags)" dh_auto_build --parallel

override_dh_auto_clean: config.status
	make clean

override_dh_clean:
	dh_clean
	rm -vf Makefile.inc config.status *.spec
	rm -vf debian/glite-lb-bkserverd.init

override_dh_strip:
	dh_strip --dbg-package=$(p_dbg)

override_dh_auto_install:
	dh_auto_install
	rm -vf debian/tmp/usr/lib/*.la
	rm -vf debian/tmp/usr/lib/*.a
	rm -rvf debian/tmp/etc/init.d
	mkdir -p debian/$(p_base)/usr/share/doc
	mv debian/tmp/usr/share/doc/$(p_base) debian/$(p_base)/usr/share/doc/$(p_base)

override_dh_install:
	cp -p config/startup.debian.bkserverd debian/glite-lb-bkserverd.init
	dh_install --fail-missing

override_dh_installdocs:
	dh_installdocs --link-doc=$(p_base)

override_dh_installinit:
	dh_installinit -p$(p_base) --name=glite-lb-bkserverd

=== debian/watch ===
version=3
http://scientific.zcu.cz/emi/emi.lb.server/glite-lb-server-(.*)\.tar\.gz
